+ void
+ route_add(unsigned long net, unsigned long mask, unsigned long router, struct device *dev)
+ {
+   struct rtable *rt;
+   struct rtable *r1=NULL;
+   struct rtable *r2=NULL;
+ 
+   if (mask == 0) mask=get_mask(net);
+   net = net & mask;
+ 
+   PRINTK (("route_add: "));
+   PRINTK (("address=%s ", in_ntoa(net)));
+   PRINTK (("mask=%s ", in_ntoa(mask)));
+   PRINTK (("router=%s DEV=%X\n", in_ntoa(router), dev));
+ 
+   for (r1 = rt_base; r1 && ((r1->mask) > mask); r1=r1->next)
+     if (r1 != rt_base) r2=r1;
+ 
+   for (;r1 && ((r1->mask) == mask); r1=r1->next)
+   {
+     if (r1->net == net)
+     {
+     PRINTK (("replacing: %s %s %s\n",in_ntoa(r1->net),in_ntoa(r1->mask),in_ntoa(r1->router)));
+     r1->mask = mask;
+     r1->router = router;
+     r1->dev = dev;
+     r1->use = 0;
+     return;
+     }
+     r2=r1;
+ }
+ 
+   PRINTK (("adding route\n"));
+   rt = kmalloc (sizeof (*rt), GFP_KERNEL);
+   if (rt == NULL) return;
+   rt->net = net;
+   rt->mask = mask;
+   rt->router = router;
+   rt->dev = dev;
+   rt->use = 0;
+   cli();
+   if (r1 == rt_base)
+   {
+     rt->next = rt_base;
+     rt_base = rt;
+   }
+   else
+   {
+   rt->next = r1;
+   r2->next = rt;
+   }
+   sti();
+ }
+ 
  /* these two routines will do routining. */
  static  void
  strict_route(struct ip_header *iph, struct options *opt)
***************
*** 255,272 ****
  ip_route(struct options *opt, unsigned long daddr, unsigned long *raddr)
  {
    struct rtable *rt;
    /* look through the routing table for some
       kind of match. */
    for (rt=rt_base; rt != NULL; rt=rt->next)
!     {
!       /* see if we found one. */
!       if (ip_addr_match (rt->net, daddr))
! 	{
! 	  PRINTK (("IP: %X via %s (%X)\n", daddr, rt->dev->name, rt->router));
  	  *raddr = rt->router;
  	  return (rt->dev);
- 	}
      }
    return (NULL);
  };
  
--- 379,404 ----
  ip_route(struct options *opt, unsigned long daddr, unsigned long *raddr)
  {
    struct rtable *rt;
+ 
+   PRINTK (("ip route: %s \n", in_ntoa(daddr)));
+ 
+   /* cheat with a local address, to force it to go through the loopback device */
+   if (my_ip_addr(daddr)) daddr = 0x0100007f;
+ 
    /* look through the routing table for some
       kind of match. */
    for (rt=rt_base; rt != NULL; rt=rt->next)
!   {
!   /* see if we found one. */
!     if ((rt->net == 0) ||((daddr & rt->mask) == rt->net))
!     {
! 	  PRINTK (("IP: %s via %s ",in_ntoa(daddr), rt->dev->name));
! 	  PRINTK (("(%s)\n", in_ntoa(rt->router)));
! 	  rt->use++;
  	  *raddr = rt->router;
  	  return (rt->dev);
      }
+   }
    return (NULL);
  };
  
***************
*** 519,528 ****
    static int count = 0;
    unsigned long raddr; /* for the router. */
    int tmp;
    if (saddr == 0) saddr = MY_IP_ADDR;
!   PRINTK (("ip_build_header (skb=%X, saddr=%X, daddr=%X, *dev=%X,\n"
! 	   "                 type=%d, opt=%X, len = %d)\n",
! 	   skb, saddr, daddr, *dev, type, opt, len));
    buff = (unsigned char *)(skb + 1);
    /* see if we need to look up the device. */
    if (*dev == NULL)
--- 558,569 ----
    static int count = 0;
    unsigned long raddr; /* for the router. */
    int tmp;
+ 
    if (saddr == 0) saddr = MY_IP_ADDR;
! 
!   PRINTK (("ip_build_header (skb=%X saddr=%s, ", skb, in_ntoa(saddr)));
!   PRINTK (("daddr=%s, ", in_ntoa(daddr)));
!   PRINTK (("*dev=%X,\n                 type=%d, opt=%X, len = %d)\n", *dev, type, opt, len));
    buff = (unsigned char *)(skb + 1);
    /* see if we need to look up the device. */
    if (*dev == NULL)
***************
*** 539,544 ****
--- 580,587 ----
        /* we still need the address of the first hop. */
        ip_route (&optmem, daddr, &raddr);
      }
+ 
+   PRINTK(("ip_build_header raddr=%s\n", in_ntoa(raddr)));
    if (raddr == 0) raddr = daddr;
    /* now build the header. */
    /* we need to worry about routing in here.  daddr should
***************
*** 814,819 ****
--- 857,863 ----
    static struct options opt; /* since we don't use these yet, and they
  				take up stack space. */
    struct ip_protocol *ipprot;
+   int type;  /* type of address */
  
    iph=skb->h.iph;
  
***************
*** 822,828 ****
  
    if (ip_csum (iph) || do_options (iph,&opt) || iph->version != 4)
      {
!        PRINTK (("ip packet thrown out. \n"));
         skb->sk = NULL;
         kfree_skb(skb, 0);
         return (0);
--- 866,874 ----
  
    if (ip_csum (iph) || do_options (iph,&opt) || iph->version != 4)
      {
! 	printk("Packet of unkown type:");
! 	printk(" saddr=%s,", in_ntoa(iph->saddr));
! 	printk(" daddr=%s (ignored)\n", in_ntoa(iph->daddr));
         skb->sk = NULL;
         kfree_skb(skb, 0);
         return (0);
***************
*** 829,857 ****
      }
  
    /* for now we will only deal with packets meant for us. */
!   if (!my_ip_addr(iph->daddr))
!     {
! 	PRINTK(("\nIP: *** datagram routing not yet implemented ***\n"));
! 	PRINTK(("    SRC = %s   ", in_ntoa(iph->saddr)));
! 	PRINTK(("    DST = %s (ignored)\n", in_ntoa(iph->daddr)));
! /*      icmp_reply (skb, ICMP_DEST_UNREACH, ICMP_PROT_UNREACH, dev); */
  
!        skb->sk = NULL;
!        kfree_skb(skb, 0);
!        return (0);
!     }
  
    /* deal with fragments.  or don't for now.*/
    if ((iph->frag_off & 32) || (net16(iph->frag_off)&0x1fff))
!     {	/* FIXME: this ^^^ used to be 64, as per bugfix */
! 	printk("\nIP: *** datagram fragmentation not yet implemented ***\n");
! 	printk("    SRC = %s   ", in_ntoa(iph->saddr));
! 	printk("    DST = %s (ignored)\n", in_ntoa(iph->daddr));
!        icmp_reply (skb, ICMP_DEST_UNREACH, ICMP_PROT_UNREACH, dev);
!        skb->sk = NULL;
!        kfree_skb(skb, 0);
!        return(0);
!     }
  
    skb->h.raw += iph->ihl*4;
  
--- 875,912 ----
      }
  
    /* for now we will only deal with packets meant for us. */
!   type=check_addr(iph->daddr);
  
!   if (!type)
!   {
!     printk("Packet not for us:");
!     printk(" saddr=%s,", in_ntoa(iph->saddr));
!     printk(" daddr=%s (ignored)\n", in_ntoa(iph->daddr));
!     skb->sk = NULL;
!     kfree_skb(skb, 0);
!     return (0);
!   }
  
    /* deal with fragments.  or don't for now.*/
    if ((iph->frag_off & 32) || (net16(iph->frag_off)&0x1fff))
!   {	/* FIXME: this ^^^ used to be 64, as per bugfix */
!     printk("Packet fragmented:");
!     printk(" saddr=%s,", in_ntoa(iph->saddr));
!     printk(" daddr=%s (ignored)\n", in_ntoa(iph->daddr));
!     if (type != IP_BROAD)
!       icmp_reply (skb, ICMP_DEST_UNREACH, ICMP_PROT_UNREACH, dev);
!     skb->sk = NULL;
!     kfree_skb(skb, 0);
!     return(0);
!   }
! 
! /*
! 	printk("Packet received:");
!     printk ("type= %d,", type);
!     printk(" saddr=%s,", in_ntoa(iph->saddr));
!     printk(" daddr=%s,", in_ntoa(iph->daddr));
!     printk(" prot=%d\n", iph->protocol);
! */
  
    skb->h.raw += iph->ihl*4;
  
***************
*** 892,903 ****
  
      }
    if (!flag)
!     {
!        icmp_reply (skb, ICMP_DEST_UNREACH, ICMP_PROT_UNREACH, dev);
!        skb->sk = NULL;
!        kfree_skb (skb, 0);
!     }
! 
  
    return (0);
  }
--- 947,962 ----
  
      }
    if (!flag)
!   {
!     printk("No idea what to do with this packet");
!     printk("    SRC = %s   ", in_ntoa(iph->saddr));
!     printk("    DST = %s (ignored)\n", in_ntoa(iph->daddr));
!     if (type != 2)
!     if (type != IP_BROAD)
!       icmp_reply (skb, ICMP_DEST_UNREACH, ICMP_PROT_UNREACH, dev);
!     skb->sk = NULL;
!     kfree_skb (skb, 0);
!   }
  
    return (0);
  }
***************
*** 914,919 ****
--- 973,979 ----
  {
    struct ip_header *iph;
    unsigned char *ptr;
+ 
    if (sk == NULL) free = 1;
  
    if (dev == NULL)
***************
*** 922,927 ****
--- 982,989 ----
        return;
      }
  
+   PRINTK (("ip_queue_xmit: dev=%s, ", dev->name));
+ 
    skb->free = free;
    skb->dev = dev;
    skb->when = jiffies;
***************
*** 934,939 ****
--- 996,1004 ----
    print_iph(iph);
    skb->next = NULL;
  
+   PRINTK (("saddr=%s, ", in_ntoa(iph->saddr)));
+   PRINTK (("daddr=%s\n", in_ntoa(iph->daddr)));
+ 
    /* see if this is the one
       trashing our queue. */
    skb->magic = 1;
***************
*** 965,977 ****
    if (dev->up)
      {
         if (sk != NULL)
- 	 {
  	   dev->queue_xmit(skb, dev, sk->priority);
- 	 }
         else
- 	 {
  	   dev->queue_xmit (skb, dev, SOPRI_NORMAL);
! 	 }
      }
    else
      {
--- 1030,1050 ----
    if (dev->up)
      {
         if (sk != NULL)
  	   dev->queue_xmit(skb, dev, sk->priority);
         else
  	   dev->queue_xmit (skb, dev, SOPRI_NORMAL);
! 
!        if (check_addr(iph->daddr)==IP_BROAD)
!        {
!        /* send a copy via the loopback device */
!          printk ("Broadcast\n");
!          printk ("saddr=%s, ", in_ntoa(iph->saddr));
!          printk ("daddr=%s\n", in_ntoa(iph->daddr));
!          if (sk != NULL)
! 	     dev_base->queue_xmit(skb, dev_base, sk->priority);
!          else
! 	     dev_base->queue_xmit (skb, dev_base, SOPRI_NORMAL);
!        }
      }
    else
      {
